<html>
<head>
<title>漢字変換の候補を表示</title>
</head>
<body>
<h1>漢字変換の候補を表示</h1>
<?php
/* 必要なもの:
 * - PHP 5
 * - SOAP extension
 * - OpenSSL extension
 */

// 入力する変数($query)の設定
// デフォルトは「亮介から電話です」
if(isset($_REQUEST['query'])){
  $query = $_REQUEST['query'];
}else{
  $query= "ryousuke kara denwa desu"; 
}

// 入力フォームの表示
$action = $_SERVER['PHP_SELF'];
echo <<<EOP
<form action="$action" method="get">
<p>
<input type="text" name="query" value="$query" size="60">
<input type="submit" >
</p>
</form>
EOP;

// 変換候補の取得
// SOAPでSumibiサーバと通信
$sumibi = new SoapClient("http://www.sumibi.org/sumibi/Sumibi_stable.wsdl");
$response = $sumibi->doSumibiConvert( $query, "sumi_current", "utf-8", "utf-8" );
$elements = $response->resultElements;

// 結果の出力
// "no"の値ごとにリストで表示
print "<ul style='float:left'>\n";
foreach ($elements as $seq => $element) {
  print "<li>$element->word</li>\n";    
  if (count($elements) == $seq + 1) {
    print "</ul>\n";
  } else if ($elements[$seq]->no != $elements[$seq + 1]->no) {
    print "</ul>\n";
    print "<ul style='float:left'>\n";
  }
}
?>
</body>
</html>
