<html>
<head>
<title>時差を取得します</title>
</head>
<body>
<h1>時差を取得します</h1>
<?php
// 変数群の設定
// 対象 (デフォルト: ニューヨーク(-5) )
if(isset($_REQUEST['topic_lat'])){
  $topic_lat = (float)$_REQUEST['topic_lat'];
}else{
  $topic_lat = 40.7;
}

if(isset($_REQUEST['topic_lng'])){
  $topic_lng = (float)$_REQUEST['topic_lng'];
}else{
  $topic_lng = -70.4;
}

// 基準 (デフォルト: 東京(+9) )
if(isset($_REQUEST['standard_lat'])){
  $standard_lat = (float)$_REQUEST['standard_lat'];
}else{
  $standard_lat = 35.7;
}

if(isset($_REQUEST['standard_lng'])){
  $standard_lng = (float)$_REQUEST['standard_lng'];
}else{
  $standard_lng = 135.8;
}
?>
<h2>対象場所と基準場所を入力します</h2>
<form action="<?php echo $_SERVER["PHP_SELF"]; ?>" method="get">
<dl>
<dt>対象</dt>
<dd>
<ul>
  <li>緯度:
    <input type="text" name="topic_lat"
      value="<?php echo $topic_lat ?>">
  </li>
  <li>経度:
    <input type="text" name="topic_lng"
      value="<?php echo $topic_lng ?>">
  </li>
</ul>
</dd>
<dt>基準</dt>
<dd>
<ul>
  <li>緯度:
    <input type="text" name="standard_lat"
      value="<?php echo $standard_lat ?>">
  </li>
  <li>経度:
    <input type="text" name="standard_lng"
      value="<?php echo $standard_lng ?>">
  </li>
</ul>
</dd>
<dt><input type="submit"></dt>
</dl>
</form>
<?php
// 処理

// Timezone APIを用いて地点の標準時を取得する関数
function getTimeZone($lat, $lng)
{
  // リクエストの作成
  $req = "http://www.earthtools.org/timezone-1.1/";
  $req .= $lat;
  $req .= "/".$lng;

  // レスポンスをパースして"offset"要素を取得
  $res = simplexml_load_file($req);
  return (int)$res->offset;
}

// 各地点の標準時を取得
$standard_tz = getTimeZone($standard_lat, $standard_lng);
$topic_tz = getTimeZone($topic_lat, $topic_lng);


// 時差の計算
$dif = $topic_tz - $standard_tz;
?>
<h2>結果</h2>
<p>2地点間の時差は<strong><?php echo $dif ?></strong>時間です</p>
</body>
</html>
