<?php

// タグを解析する
function parseBody($body)
{
    while (preg_match('!<wikipedia>(.*?)</wikipedia>!', $body, $match)) {
        $replaced = getWikipedia($match[1]);
        $body = str_replace($match[0], $replaced, $body);
    }

    return $body;
}

// キーワードを置換する
function getWikipedia($word)
{
    $url = 'http://wikipedia.simpleapi.net/api?output=xml&keyword=' . $word;
    $xml = @simplexml_load_file($url);
    if ($xml) {
        return '<a href="' . $xml->result->url . '" title="' . strip_tags($xml->result->body) . '">' . $word . '</a>';
    } else {
        return $word;
    }
}

?>

