<html>
<head>
<title>兄弟サイトの取得</title>
</head>
<body>
<h1>兄弟サイトの取得
  <!-- Begin Yahoo! JAPAN Web Services Attribution Snippet -->
  <a href="http://developer.yahoo.co.jp/about">
  <img src="http://i.yimg.jp/images/yjdn/yjdn_attbtn1_88_35.gif"
    width="88" height="35" title="Webサービス by Yahoo! JAPAN"
    alt="Web Services by Yahoo! JAPAN" border="0"
    style="margin:15px 15px 15px 15px">
  </a>
  <!-- End Yahoo! JAPAN Web Services Attribution Snippet -->
</h1>

<?php
// アプリケーションID(開発の事前に取得)
$APP_ID = "refbook_sample_category";

// 対象とするサイトのURL $myUrl のパース
// 初期値は「埼玉県立近代美術館ホームページ」
if(isset($_REQUEST['myUrl'])){
  $myUrl = $_REQUEST['myUrl'];
}else{
  $myUrl = "http://www.momas.jp/";
}
?>

<!-- URL入力フォーム -->
<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="get">
<p>
  URL:<input type="text" name="myUrl" value="<?php echo $myUrl ?>" size="40">
  <input type="submit" >
</p>
</form>

<?php
// $myUrlの属するカテゴリ$myCatを取得
// ディレクトリサーチを利用

// リクエストの作成
$req = "http://api.dir.yahoo.co.jp/Category/V1/directorySearch?";
$req .= "appid=" . $APP_ID;
$req .= "&query=" . urlencode($myUrl);
$req .= "&type=2"; //サイトデータのみ

// レスポンスの取得
$res = simplexml_load_file($req) or die("directorySearch API NULL response");

// $myCatの取得
// "Item"のうちで"Url"が$myUrlと一致するアイテムの"Parent"
// 親カテゴリが複数ある場合は一番先に見つかったものを採用
$myCat = NULL;
foreach ($res->SiteSearchResults->Item as $item) {
  if ($item->Url == $myUrl) {
    $myCat = $item->Parent;
    break;
  }
}

if (!$myCat) {
  die("NULL myCat");
}

// $myCatに属するサイトのリスト$brosを取得
// ディレクトリツリーを利用

// リクエストの作成
$req = "http://api.dir.yahoo.co.jp/Category/V1/Category?";
$req .= "appid=" . $APP_ID;
$req .= "&id=" . $myCat;
$req .= "&type=2"; //サイトデータのみ

// レスポンスの取得
$res = simplexml_load_file($req) or die("Category API NULL response");

// Webサイトのクラス
class Site {
  var $url, $title;
  function Site($url, $title)
  {
    $this->url = $url;
    $this->title = $title;
  }
}

// $brosの取得
// 各"Item"の"Url"。$myUrlと同じなら除外
$bros = array();
foreach ($res->Sites->Item as $item) {
  if ($item->Url && $item->Url != $myUrl) {
    $site = new Site($item->Url, $item->Title);
    $bros[] = $site;
  }
}
if (!$bros){
  die("NULL bros");
}

// $brosの表示
// 記述のしかたは <li><a href="URL">URL</a>(TITLE)</li>
print "<ul>\n";
foreach ($bros as $site) {
  print '<li><a href="' . $site->url . '">' . $site->url . '</a>
    (' . $site->title . ')</li>' . "\n";
}
print "</ul>\n";

?>
</body>
</html>
